<?php

@set_time_limit(0);
@ignore_user_abort(TRUE);
ini_set('max_execution_time', 0);
ini_set('mysql.connect_timeout', 0);

include_once('../source/class/class_core.php');
include_once('../source/function/function_core.php');

$cachelist = array();
$discuz = C::app();

$discuz->cachelist = $cachelist;
$discuz->init_cron = false;
$discuz->init_setting = true;
$discuz->init_user = false;
$discuz->init_session = false;
$discuz->init_misc = false;

$discuz->init();

header("Content-type: text/html; charset=utf-8");

$config = array(
	'dbcharset' => $_G['config']['db']['1']['dbcharset'],
	'charset' => $_G['config']['output']['charset'],
	'tablepre' => $_G['config']['db']['1']['tablepre']
);

$step = !empty($_GET['step']) && in_array($_GET['step'], array('welcome', 'tips', 'license', 'envcheck', 'confirm', 'config', 'innodb', 'scheme', 'utf8mb4', 'serialize', 'serialize_plugin', 'file', 'dataupdate')) ? $_GET['step'] : 'welcome';
$theurl = htmlspecialchars($_SERVER['PHP_SELF'] ? $_SERVER['PHP_SELF'] : $_SERVER['SCRIPT_NAME']);
$lockfile = DISCUZ_ROOT.'./data/update.lock';

$tables = array();

$sys_tables_not_full = array('pre_common_admincp_cmenu', 'pre_common_admincp_group', 'pre_common_admincp_member', 'pre_common_admincp_perm', 'pre_common_admincp_session', 'pre_common_admingroup', 'pre_common_adminnote', 'pre_common_advertisement', 'pre_common_advertisement_custom', 'pre_common_banned', 'pre_common_block', 'pre_common_block_favorite', 'pre_common_block_item', 'pre_common_block_item_data', 'pre_common_block_permission', 'pre_common_block_pic', 'pre_common_block_style', 'pre_common_block_xml', 'pre_common_cache', 'pre_common_card', 'pre_common_card_log', 'pre_common_card_type', 'pre_common_connect_guest', 'pre_common_credit_log', 'pre_common_credit_log_field', 'pre_common_credit_rule', 'pre_common_credit_rule_log', 'pre_common_credit_rule_log_field', 'pre_common_cron', 'pre_common_devicetoken', 'pre_common_district', 'pre_common_diy_data', 'pre_common_domain', 'pre_common_failedip', 'pre_common_failedlogin', 'pre_common_friendlink', 'pre_common_grouppm', 'pre_common_invite', 'pre_common_magic', 'pre_common_magiclog', 'pre_common_mailcron', 'pre_common_mailqueue', 'pre_common_member', 'pre_common_member_action_log', 'pre_common_member_connect', 'pre_common_member_count', 'pre_common_member_crime', 'pre_common_member_field_forum', 'pre_common_member_field_home', 'pre_common_member_forum_buylog', 'pre_common_member_grouppm', 'pre_common_member_log', 'pre_common_member_magic', 'pre_common_member_medal', 'pre_common_member_newprompt', 'pre_common_member_profile', 'pre_common_member_profile_setting', 'pre_common_member_security', 'pre_common_member_secwhite', 'pre_common_member_stat_field', 'pre_common_member_status', 'pre_common_member_validate', 'pre_common_member_verify', 'pre_common_member_verify_info', 'pre_common_myapp', 'pre_common_myinvite', 'pre_common_mytask', 'pre_common_nav', 'pre_common_onlinetime', 'pre_common_optimizer', 'pre_common_patch', 'pre_common_plugin', 'pre_common_pluginvar', 'pre_common_process', 'pre_common_regip', 'pre_common_relatedlink', 'pre_common_remote_port', 'pre_common_report', 'pre_common_searchindex', 'pre_common_seccheck', 'pre_common_secquestion', 'pre_common_session', 'pre_common_setting', 'pre_common_smiley', 'pre_common_sphinxcounter', 'pre_common_stat', 'pre_common_statuser', 'pre_common_style', 'pre_common_stylevar', 'pre_common_syscache', 'pre_common_tag', 'pre_common_tagitem', 'pre_common_task', 'pre_common_taskvar', 'pre_common_template', 'pre_common_template_block', 'pre_common_template_permission', 'pre_common_uin_black', 'pre_common_usergroup', 'pre_common_usergroup_field', 'pre_common_visit', 'pre_common_word', 'pre_common_word_type', 'pre_connect_disktask', 'pre_connect_feedlog', 'pre_connect_memberbindlog', 'pre_connect_postfeedlog', 'pre_connect_tthreadlog', 'pre_forum_access', 'pre_forum_activity', 'pre_forum_activityapply', 'pre_forum_announcement', 'pre_forum_attachment', 'pre_forum_attachment_0', 'pre_forum_attachment_1', 'pre_forum_attachment_2', 'pre_forum_attachment_3', 'pre_forum_attachment_4', 'pre_forum_attachment_5', 'pre_forum_attachment_6', 'pre_forum_attachment_7', 'pre_forum_attachment_8', 'pre_forum_attachment_9', 'pre_forum_attachment_exif', 'pre_forum_attachment_unused', 'pre_forum_attachtype', 'pre_forum_bbcode', 'pre_forum_collection', 'pre_forum_collectioncomment', 'pre_forum_collectionfollow', 'pre_forum_collectioninvite', 'pre_forum_collectionrelated', 'pre_forum_collectionteamworker', 'pre_forum_collectionthread', 'pre_forum_creditslog', 'pre_forum_debate', 'pre_forum_debatepost', 'pre_forum_faq', 'pre_forum_filter_post', 'pre_forum_forum', 'pre_forum_forum_threadtable', 'pre_forum_forumfield', 'pre_forum_forumrecommend', 'pre_forum_groupcreditslog', 'pre_forum_groupfield', 'pre_forum_groupinvite', 'pre_forum_grouplevel', 'pre_forum_groupuser', 'pre_forum_hotreply_member', 'pre_forum_hotreply_number', 'pre_forum_imagetype', 'pre_forum_medal', 'pre_forum_medallog', 'pre_forum_memberrecommend', 'pre_forum_moderator', 'pre_forum_modwork', 'pre_forum_newthread', 'pre_forum_onlinelist', 'pre_forum_order', 'pre_forum_poll', 'pre_forum_polloption', 'pre_forum_polloption_image', 'pre_forum_pollvoter', 'pre_forum_post', 'pre_forum_post_location', 'pre_forum_post_moderate', 'pre_forum_post_tableid', 'pre_forum_postcache', 'pre_forum_postcomment', 'pre_forum_postlog', 'pre_forum_poststick', 'pre_forum_promotion', 'pre_forum_ratelog', 'pre_forum_relatedthread', 'pre_forum_replycredit', 'pre_forum_rsscache', 'pre_forum_sofa', 'pre_forum_spacecache', 'pre_forum_statlog', 'pre_forum_thread', 'pre_forum_thread_moderate', 'pre_forum_threadaddviews', 'pre_forum_threadcalendar', 'pre_forum_threadclass', 'pre_forum_threadclosed', 'pre_forum_threaddisablepos', 'pre_forum_threadhidelog', 'pre_forum_threadhot', 'pre_forum_threadimage', 'pre_forum_threadlog', 'pre_forum_threadmod', 'pre_forum_threadpartake', 'pre_forum_threadpreview', 'pre_forum_threadprofile', 'pre_forum_threadprofile_group', 'pre_forum_threadrush', 'pre_forum_threadtype', 'pre_forum_trade', 'pre_forum_tradecomment', 'pre_forum_tradelog', 'pre_forum_typeoption', 'pre_forum_typeoptionvar', 'pre_forum_typevar', 'pre_forum_warning', 'pre_home_album', 'pre_home_album_category', 'pre_home_appcreditlog', 'pre_home_blacklist', 'pre_home_blog', 'pre_home_blog_category', 'pre_home_blog_moderate', 'pre_home_blogfield', 'pre_home_class', 'pre_home_click', 'pre_home_clickuser', 'pre_home_comment', 'pre_home_comment_moderate', 'pre_home_docomment', 'pre_home_doing', 'pre_home_doing_moderate', 'pre_home_favorite', 'pre_home_feed', 'pre_home_feed_app', 'pre_home_follow', 'pre_home_follow_feed', 'pre_home_follow_feed_archiver', 'pre_home_friend', 'pre_home_friend_request', 'pre_home_friendlog', 'pre_home_notification', 'pre_home_pic', 'pre_home_pic_moderate', 'pre_home_picfield', 'pre_home_poke', 'pre_home_pokearchive', 'pre_home_share', 'pre_home_share_moderate', 'pre_home_show', 'pre_home_specialuser', 'pre_home_userapp', 'pre_home_userappfield', 'pre_home_visitor', 'pre_mobile_setting', 'pre_mobile_wsq_threadlist', 'pre_portal_article_content', 'pre_portal_article_count', 'pre_portal_article_moderate', 'pre_portal_article_related', 'pre_portal_article_title', 'pre_portal_article_trash', 'pre_portal_attachment', 'pre_portal_category', 'pre_portal_category_permission', 'pre_portal_comment', 'pre_portal_comment_moderate', 'pre_portal_rsscache', 'pre_portal_topic', 'pre_portal_topic_pic', 'pre_security_evilpost', 'pre_security_eviluser', 'pre_security_failedlog', 'pre_common_member_archive', 'pre_common_member_profile_archive', 'pre_common_member_field_forum_archive', 'pre_common_member_field_home_archive', 'pre_common_member_status_archive', 'pre_common_member_count_archive', 'pre_common_member_wechat', 'pre_mobile_wechat_authcode', 'pre_common_member_wechatmp', 'pre_mobile_wsq_threadlist', 'pre_mobile_wechat_resource', 'pre_mobile_wechat_masssend');

$scheme_count = 0;

if (in_array($_GET['step'], array('innodb', 'utf8mb4', 'serialize', 'serialize_plugin'))) {
	$db_result = DB::fetch_all('SHOW TABLE STATUS WHERE `Name` LIKE \''.$config['tablepre'].'%\';');
	foreach ($db_result as $tb) {
		if (strstr($tb['Name'], $config['tablepre'].'ucenter_') || strstr($tb['Name'], $config['tablepre'].'uc_')) {
			continue;
		}
		$tables = array_merge($tables, array(str_replace($config['tablepre'], 'pre_', $tb['Name'])));
	}
}

$table = empty($_GET['table']) ? $tables[0] : $_GET['table'];

if (!empty($_GET['lock'])) {
	@touch($lockfile);
	@unlink($theurl);
	show_msg('恭喜，您已经成功升级到 Discuz! X3.5 版本，感谢您的使用！');
}

if (file_exists($lockfile)) {
	show_msg('请您先登录服务器，手工删除 data/update.lock 文件，再次运行本文件进行升级。');
}

if ($step == 'welcome') {

	show_msg('<p class="lead">Discuz! X3.5 在继承和完善 Discuz! X3.4 宗旨的基础上， Discuz! 社区以“不忘初心”为主线，针对“系统安全”、“IPv6”、“运营拓展”、“负载性能”、“用户体验”和“管理体验”几大方面，全面优化和打造，功能改进多达 1 余项。本程序将不定期的在官方 Git 中更新，欲追求更新版本的站长欢迎关注。</p><p class="lead">本程序将引导您从 Discuz! X3.4 升级至 Discuz! X3.5 ，请在升级之前做好站点全量数据（含数据库、文件）的备份操作，并小心操作。</p><p class="lead">在您准备好进行操作之后，点击“下一步”按钮继续操作。</p><p><button type="button" class="btn btn-primary" onclick="location.href=\'?step=tips\';">下一步 ></button></p>', '欢迎您执行 Discuz! X3.5 升级程序', 1);

} else if ($step == 'tips') {

	show_msg('<p class="lead">本程序将引导您从 Discuz! X3.4 升级至 Discuz! X3.5 ，请在升级之前做好站点全量数据（含数据库、文件）的备份操作，并小心操作。</p><p class="lead">由于 UCenter 1.7.0 更新了数据库编码，对于您当前数据库内不支持 utf8mb4_unicode_ci 编码的用户名，UCenter 程序会将用户重命名为 15 位随机字符，请您自行在升级成功后在 UCenter 后台查询用户更名日志和通知日志，保证更名通知已经成功下发到各应用后再进行应用升级操作（对于 UCenter 对接其他非 Discuz! X 系统的站点，请确认应用正确实现了 UCenter 通知改名接口。），并在升级完成后通过站点公告、电子邮件、手机短信等多种方式手动通知此类用户通过更名卡等方式自行修改用户名。如果需要通过更名卡方式修改用户名的站点，请在转换完成后手动在后台配置道具中心的更名卡，以支持上述用户自助改名。</p><p class="lead">由于 UCenter 1.7.0 更新了数据库编码，为了防止安全提问内的中文影响用户登录，因此将为您清空安全提问，请将此情况如实告知用户，并要求用户在登录时请不要输入安全提问。如您希望自行编写兼容代码，请自行在后续流程选择不清空用户的安全提问。</p><p class="lead">由于 UCenter 1.7.0 更新了数据库编码，对于极个别采用非标准字符集用作密码的账号可能会出现密码错误的情况，遇到此情况请引导用户选择找回密码并按提示操作找回密码，重新设置密码后即可重新登录。</p><p class="lead">由于 Discuz! X3.5 更新了 IP 黑名单存储方式，因此对于系统内当前批量封禁的 IP 地址，只支持 IPv4 地址规则，且地址掩码为 8 的整数倍且不大于 32 的存量数据，数据库内原有数据将自动删除。建议您在升级前导出原规则，如有需要请在升级后按新系统规则重新配置。</p><p class="lead">由于 Discuz! X3.5 对 Session 、 IP 黑名单功能进行了优化，此类优化由于依赖部分高级特性，因此不支持除 Redis 外的其它内存缓存库。因此如果您的站点流量较大，建议您卸载原有内存缓存库，更换内存缓存库为 Redis ，这样可以最大程度的优化您站点的运行速度，并且不依赖数据库内的 HEAP 表。</p><p class="lead">由于 Discuz! X3.5 对站点功能开关功能进行了优化，升级完成后将为您打开站点所有功能，请在升级完成后自行评估您站点运营具体需要开启的功能，并根据站点运营需求关闭不需要的功能。</p><p class="lead">由于 Discuz! X3.5 更新了数据库编码和默认模板，升级程序会将程序数据表和插件数据表转换至 utf8mb4 ，并试图对您的插件文件进行转码，同时在升级完成后将关闭所有非系统插件并恢复默认风格。请您在升级完成后对您的插件进行验证，对于多数插件、模板而言，在转换之后可在 utf8mb4 环境下继续运行或进行少量改造后继续运行，少量插件、模板可能需要自行对文件做转码，甚至进行一定程度的改造才能够正常在 Discuz! X3.5 上运行。</p><p class="lead">请不要重复执行本程序，重复执行可能导致未知的问题，如遇升级出错请不要关闭页面，尝试根据提示解决后刷新继续，如无法实现请恢复备份重新开始升级。</p><p class="lead">在您准备好进行操作之后，点击“下一步”按钮继续操作。</p><p><button type="button" class="btn btn-primary" onclick="location.href=\'?step=license\';">下一步 ></button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=welcome\';">上一步 <</button></p>', '请您阅读升级提示', 1);

} else if ($step == 'license') {

	show_msg('<p class="lead">请点击 <a href="https://gitee.com/ComsenzDiscuz/DiscuzX/raw/master/readme/license.txt" target="_blank">https://gitee.com/ComsenzDiscuz/DiscuzX/raw/master/readme/license.txt</a> 链接查看最新版最终用户授权协议。</p><p><button type="button" class="btn btn-primary" onclick="location.href=\'?step=envcheck\';">同意并下一步 ></button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=tips\';">上一步 <</button></p>', '请您阅读最终用户授权协议', 1);

} else if ($step == 'envcheck') {

	include_once('../config/config_ucenter.php');
	include_once('../source/discuz_version.php');
	include_once('../uc_client/client.php');

	$tips = '<table class="table table-striped" style="margin: 2em 0;"><thead><tr><th scope="col">软件名称</th><th scope="col">最低要求</th><th scope="col">当前状态</th><th scope="col">是否满足</th></tr></thead><tbody>';
	$env_ok = true;
	$now_ver = array('Code Version' => preg_replace('/[^0-9.]+/', '', constant('DISCUZ_VERSION')), 'UCenter' => uc_check_version()['db'], 'PHP' => constant('PHP_VERSION'), 'MySQL' => helper_dbtool::dbversion(), 'GD' => (function_exists('gd_info') ? preg_replace('/[^0-9.]+/', '', gd_info()['GD Version']) : false), 'XML' => function_exists('xml_parser_create'), 'mbstring' => (function_exists('mb_convert_encoding') || strtoupper(constant('CHARSET')) == 'UTF-8'));// 对于UTF-8用户，不强制要求mbstring扩展
	$req_ver = array('Code Version' => '3.5', 'UCenter' => '1.6.0', 'PHP' => '5.6.0', 'MySQL' => '5.5.3', 'GD' => '1.0', 'XML' => true, 'mbstring' => true);// Todo: UCenter 版本1.7.0
	foreach ($now_ver as $key => $value) {
		$tips .= "<tr><th>$key</th><td>$req_ver[$key]</td><td>$value</td>";
		if ($req_ver[$key] === true) {
			if (!$value) {
				$tips .= '<td><font color="Red">❌ 不满足</font></td>';
				$env_ok = false;
			} else {
				$tips .= '<td><font color="Green">✔️ 满足</font></td>';
			}
		} else if (version_compare($value, $req_ver[$key], '<')) {
			$tips .= '<td><font color="Red">❌ 不满足</font></td>';
			$env_ok = false;
		} else {
			$tips .= '<td><font color="Green">✔️ 满足</font></td>';
		}
		$tips .= '</tr>';
	}
	$tips .= '</tbody></table><p>';
	$env_ok && $tips .= '<button type="button" class="btn btn-primary" onclick="location.href=\'?step=confirm\';">下一步 ></button> ';
	$tips .= '<button type="button" class="btn btn-secondary" onclick="location.href=\'?step=license\';">上一步 <</button></p>';
	show_msg($tips, '环境检测', 1);

} else if ($step == 'confirm') {

	show_msg('<p class="lead" style="color: red;font-weight: bold;">本程序即将开始将您的 Discuz! X3.4 升级至 Discuz! X3.5 ，请确认现在已经做好站点全量数据（含数据库、文件）的备份操作！当您点击“开始升级”时，升级将不可逆的开始！</p><p><button type="button" class="btn btn-primary" onclick="location.href=\'?step=config\';">开始升级 ></button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=config&myisam=1\';">不升级到InnoDB（不推荐） > </button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=license\';">上一步 <</button></p>', '确认开始', 1);

} else if ($step == 'config') {

	if (!C::t('common_setting')->fetch('bbclosed')) {
		C::t('common_setting')->update('bbclosed', 1);
		require_once libfile('function/cache');
		updatecache('setting');
		show_msg('您的站点未关闭，正在关闭，请稍候......', '提示信息', 0, $theurl.'?step=config');
	}

	$stepurl = $theurl . empty($_GET['myisam']) ? '?step=innodb' : '?step=scheme&myisam=1';

	$deletevar = array('app', 'home'); // config中需要删除的项目
	$default_config = $_config = array();
	$default_configfile = DISCUZ_ROOT.'./config/config_global_default.php';

	if (!file_exists($default_configfile)) {
		show_msg('<font color="red"><b>config_global_default.php 不存在，无法继续操作，请补充此文件后刷新页面再试。</b></font>', '提示信息');
	} else {
		include $default_configfile;
		$default_config = $_config;
	}

	$configfile = DISCUZ_ROOT.'./config/config_global.php';
	include $configfile;

	if (save_config_file($configfile, $_config, $default_config, $deletevar)) {
		show_msg("系统配置设置成功，即将进行下一步操作，请稍候......", '提示信息', 0, "$stepurl");
	} else {
		show_msg('<font color="red"><b>由于配置文件不可写，程序自动修改配置文件失败。由于 "config/" 目录不可写入，我们已将更新的文件保存到 "data/" 目录下，请通过 FTP 软件将其转移到 "config/" 目录下覆盖源文件。随后 <a href="'.$stepurl.'">点击此处</a> 继续操作。</b></font>', '提示信息');
	}

} else if ($step == 'innodb') {

	@touch(DISCUZ_ROOT.'./data/install.lock');
	@unlink(DISCUZ_ROOT.'./install/index.php');

	if (!in_array($table, array('pre_common_member_secwhite', 'pre_common_process', 'pre_common_seccheck', 'pre_common_session', 'pre_common_visit', 'pre_forum_threaddisablepos'))) {
		$sql_check = get_convert_sql('check', $table);
		if (!empty($sql_check)) {
			$result = DB::fetch_first($sql_check);
			if ($result['Engine'] != 'InnoDB') {
				$sql = get_convert_sql($step, $table);
				if (!empty($sql)) {
					// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
					// DB::query('SET GLOBAL connect_timeout=28800');
					// DB::query('SET GLOBAL wait_timeout=28800');
					// DB::query('SET GLOBAL interactive_timeout=28800');
					if (empty($_GET['scheme']) && (in_array($table, array('pre_common_syscache', 'pre_forum_rsscache', 'pre_common_searchindex', 'pre_forum_spacecache', 'pre_common_banned', 'pre_common_member_grouppm', 'pre_forum_post')))) {
						DB::query(get_innodb_scheme_update_sql($table));
						show_msg("InnoDB数据表升级进行中，$table 结构预调整完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step."&table=".$table."&scheme=1");
					}
					DB::query($sql);
				}
			}
		}
	}

	$tmp = array_flip($tables);
	$tmpid = $tmp[$table];
	$count = count($tables);
	if ($tmpid + 1 < $count) {
		$next = $tables[++$tmpid];
		show_msg("InnoDB数据表升级进行中，$table 表升级已完成，当前进度 $tmpid / $count ，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step."&table=".$next);
	} else {
		show_msg("InnoDB数据表升级完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=scheme");
	}

} else if ($step == 'scheme') {

	@touch(DISCUZ_ROOT.'./data/install.lock');
	@unlink(DISCUZ_ROOT.'./install/index.php');

	$id = empty($_GET['id']) ? 0 : intval($_GET['id']);
	$type = empty($_GET['myisam']) ? 'InnoDB' : 'MyISAM';

	$sql = get_scheme_update_sql($id, $type);
	if (!empty($sql)) {
		// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
		// DB::query('SET GLOBAL connect_timeout=28800');
		// DB::query('SET GLOBAL wait_timeout=28800');
		// DB::query('SET GLOBAL interactive_timeout=28800');
		DB::query($sql);
		show_msg("数据库结构升级进行中，当前进度 $id / $scheme_count ，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step."&myisam=".(empty($_GET['myisam']) ? 0 : 1)."&id=".++$id);
	} else {
		show_msg("数据库结构升级完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=utf8mb4");
	}

} else if ($step == 'utf8mb4') {

	$sql_check = get_convert_sql('check', $table);
	if (!empty($sql_check)) {
		$result = DB::fetch_first($sql_check);
		if ($result['Collation'] != 'utf8mb4_unicode_ci') {
			$sql = get_convert_sql('utf8mb4', $table);
			if (!empty($sql)) {
				// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
				// DB::query('SET GLOBAL connect_timeout=28800');
				// DB::query('SET GLOBAL wait_timeout=28800');
				// DB::query('SET GLOBAL interactive_timeout=28800');
				DB::query($sql);
			}
		}
	}

	$tmp = array_flip($tables);
	$tmpid = $tmp[$table];
	$count = count($tables);
	if ($tmpid + 1 < $count) {
		$next = $tables[++$tmpid];
		show_msg("utf8mb4数据表升级进行中，$table 表升级已完成，当前进度 $tmpid / $count ，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step."&table=".$next);
	} else {
		show_msg("utf8mb4数据表升级完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=serialize");
	}

} else if ($step == 'serialize') {

	if (!isset($_GET['start']) && !isset($_GET['tid'])) {

		if ($config['dbcharset'] == 'utf8' || $config['dbcharset'] == 'utf8mb4') {
			show_msg("序列化数据转换无需进行，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=dataupdate");
		}

		$configfile = DISCUZ_ROOT.'./config/config_global.php';
		$configfile_uc = DISCUZ_ROOT.'./config/config_ucenter.php';
		if (is_writable($configfile) && is_writable($configfile_uc)) {
			$config = file_get_contents($configfile);
			$config = preg_replace("/\['dbcharset'\] = \s*'.*?'\;/i", "['dbcharset'] = 'utf8mb4';", $config);
			$config = preg_replace("/\['output'\]\['charset'\] = \s*'.*?'\;/i", "['output']['charset'] = 'utf-8';", $config);
			$fp = fopen($configfile, 'w');
			fwrite($fp, $config);
			fclose($fp);
			$config_uc = file_get_contents($configfile_uc);
			$config_uc = preg_replace("/define\('UC_DBCHARSET',\s*'.*?'\);/i", "define('UC_DBCHARSET', 'utf8mb4');", $config_uc);
			$config_uc = preg_replace("/define\('UC_CHARSET',\s*'.*?'\);/i", "define('UC_CHARSET', 'utf-8');", $config_uc);
			$fp_uc = fopen($configfile_uc, 'w');
			fwrite($fp_uc, $config_uc);
			fclose($fp_uc);
			show_msg("序列化数据转换配置设置成功，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=serialize&start=0&tid=0");
		} else {
			show_msg('<font color="red"><b>由于配置文件不可写，程序自动修改配置文件失败。需要您手工修改 config/config_global.php 和 config/config_ucenter.php ，将 dbcharset 配置 和 UC_DBCHARSET 常量手工改为 utf8mb4 ，将 charset 配置 和 UC_CHARSET 常量手工改为 utf8，随后 <a href="'.$theurl.'?step=seriallize&start=0&tid=0">点击此处</a> 继续操作。</b></font>', '提示信息');
		}

	}

	$limit = 100000;
	$nextid = 0;

	$start = empty($_GET['start']) ? 0 : intval($_GET['start']);
	$tid = empty($_GET['tid']) ? 0 : intval($_GET['tid']);

	$arr = get_serialize_list();

	$field = $arr[$tid];
	$arr[$tid];
	$stable = str_replace('pre_', $config['tablepre'], $field[0]);
	$sfield = $field[1];
	$sid = $field[2];
	$special = $field[3];

	if (in_array($field[0], $tables)) {
		if ($special) {
			$sql = "SELECT `$sfield`, `$sid` FROM `$stable` WHERE `$sid` > $start ORDER BY `$sid` ASC LIMIT $limit";
		} else {
			$sql = "SELECT `$sfield`, `$sid` FROM `$stable`";
		}

		$query = DB::query($sql);

		while ($values = DB::fetch($query)) {
			if ($special) {
				$nextid = $values[$sid];
			} else {
				$nextid = 0;
			}
			$data = $values[$sfield];
			$id = $values[$sid];
			$data = preg_replace_callback('/s:([0-9]+?):"([\s\S]*?)";/', '_serialize', $data);
			$data = addslashes($data);
			DB::query("UPDATE `$stable` SET `$sfield` = '$data' WHERE `$sid` = '$id';");
		}
	}

	if ($nextid) {
		show_msg("序列化数据转换进行中，$stable 表升级进行中，即将进行下一步操作（第 $tid 个转换项从 $nextid 开始的数据），请稍候......", '提示信息', 0, "$theurl?step=$step&tid=$tid&start=$nextid");
	} else {
		if (++$tid < count($arr)) {
			show_msg("序列化数据转换进行中，$stable 表升级进行中，即将进行下一步操作（第 $tid 个转换项从 $nextid 开始的数据），请稍候......", '提示信息', 0, "$theurl?step=$step&tid=$tid&start=0");
		} else {
			show_msg("序列化数据转换完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=serialize_plugin");
		}
	}

} else if ($step == 'serialize_plugin') {

	$tables_outside = $arr = array();

	foreach ($tables as $tb) {
		if (in_array(str_replace($config['tablepre'], 'pre_', $tb), $sys_tables_not_full)) {
			continue; // 不对系统内的表做扫描，UCenter表之前已排除过
		}
		if (preg_match('/^'.$config['tablepre'].'forum_(post|thread)_[0-9]+/i', $tb) || strstr($tb, $config['tablepre'].'forum_optionvalue')) {
			continue; // 不对系统内的表做扫描，此处排除主题、帖子分表和分类信息分表
		}
		$tables_outside = array_merge($tables_outside, array($tb));
	}

	foreach ($tables_outside as $to) {
		$to_result = DB::fetch_all("SHOW COLUMNS FROM $to;");
		foreach ($to_result as $tc) {
			if (strstr($tc['Type'], 'char') || strstr($tc['Type'], 'text')) {
				$tmp_arr = array($to, $tc['Field']);
				$arr = array_merge($arr, array($tmp_arr));
			}
		}
	}

	foreach ($arr as $field) {
		$stable = $field[0];
		$sfield = $field[1];

		if (!empty($stable) && !empty($sfield)) {
			$sql = "SELECT `$sfield` FROM `$stable`";
			$query = DB::query($sql);

			while ($values = DB::fetch($query)) {
				$data = $values[$sfield];
				if (preg_match('/s:([0-9]+?):"([\s\S]*?)";/', $data) === 1) {
					$datanew = preg_replace_callback('/s:([0-9]+?):"([\s\S]*?)";/', '_serialize', $data);
					if (unserialize($datanew) !== false) {
						$datanew = addslashes($datanew);
						DB::query("UPDATE `$stable` SET `$sfield` = '$datanew' WHERE `$sfield` = '$data';");
					}
				}
			}
		}
	}

	show_msg("第三方序列化数据转换完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=file");

} else if ($step == 'file') {

	encode_tree(__DIR__.'/../data/log/');
	encode_tree(__DIR__.'/../source/plugin/');
	encode_tree(__DIR__.'/../template/');

	show_msg("文件编码转换完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=dataupdate");

} else if ($step == 'dataupdate') {

	db_content_update();

	dir_clear(ROOT_PATH.'./data/template');
	dir_clear(ROOT_PATH.'./data/cache');
	dir_clear(ROOT_PATH.'./data/threadcache');
	dir_clear(ROOT_PATH.'./uc_client/data');
	dir_clear(ROOT_PATH.'./uc_client/data/cache');

	savecache('setting', '');
	C::memory()->clear();

	$configfile = DISCUZ_ROOT.'./config/config_global.php';
	$configfile_uc = DISCUZ_ROOT.'./config/config_ucenter.php';
	if (is_writable($configfile) && is_writable($configfile_uc)) {
		$config = file_get_contents($configfile);
		$config = preg_replace("/\['dbcharset'\] = \s*'.*?'\;/i", "['dbcharset'] = 'utf8mb4';", $config);
		$config = preg_replace("/\['output'\]\['charset'\] = \s*'.*?'\;/i", "['output']['charset'] = 'utf-8';", $config);
		$fp = fopen($configfile, 'w');
		fwrite($fp, $config);
		fclose($fp);
		$config_uc = file_get_contents($configfile_uc);
		$config_uc = preg_replace("/define\('UC_DBCHARSET',\s*'.*?'\);/i", "define('UC_DBCHARSET', 'utf8mb4');", $config_uc);
		$config_uc = preg_replace("/define\('UC_CHARSET',\s*'.*?'\);/i", "define('UC_CHARSET', 'utf-8');", $config_uc);
		$fp_uc = fopen($configfile_uc, 'w');
		fwrite($fp_uc, $config_uc);
		fclose($fp_uc);
	} else {
		show_msg('<font color="red"><b>升级成功，但由于配置文件不可写，程序自动修改配置文件失败。需要您手工修改 config/config_global.php 和 config/config_ucenter.php ，将 dbcharset 配置 和 UC_DBCHARSET 常量手工改为 utf8mb4 ，将 charset 配置 和 UC_CHARSET 常量手工改为 utf8。请不要重复执行本程序，重复执行可能导致未知的问题。</b></font><iframe src="../misc.php?mod=initsys" style="display:none;"></iframe>', '提示信息');
	}

	show_msg('数据更新完成，正在更新缓存，请稍候......<iframe src="../misc.php?mod=initsys" style="display:none;" onload="window.location.href=\''.$theurl.'?lock=1\'"></iframe>', '提示信息');

}

function show_msg($message, $title = '提示信息', $page = 0, $url_forward = '', $time = 1, $noexit = 0, $notice = '') {
	if ($url_forward) {
		$message = "<a href=\"$url_forward\">$message (跳转中......)</a><br />$notice<script>setTimeout(\"window.location.href ='$url_forward';\", $time);</script>";
	}

	if (!$page) {
		$message = '<p class="lead">'.$message.'</p>';
	}

	show_header();
	print<<<END
<main role="main" class="flex-shrink-0">
<div class="container">
<h1 class="mt-5">$title</h1>
$message
<p>$notice</p>
</div>
</main>
END;
	show_footer();
	!$noexit && exit();
}

function show_header() {
	print<<<END
<!DOCTYPE html>
<html lang="zh-cn" class="h-100">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<meta name="description" content="">
<meta name="author" content="Discuz! Community Team">
<meta name="generator" content="Discuz! Community Team">
<title>Discuz! X3.5 升级程序</title>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.4.1/dist/css/bootstrap.min.css" integrity="sha256-L/W5Wfqfa0sdBNIKN9cG6QA5F2qx4qICmU2VgLruv9Y=" crossorigin="anonymous">
<style>
main > .container {padding: 15px 15px 0;}
.footer {background-color: #f5f5f5;}
.footer > .container {padding-right: 15px; padding-left: 15px;}
code {font-size: 80%;}
.lead {margin: 2em 0; line-height: 2em;}
</style>
</head>

<body class="d-flex flex-column h-100">
<header>
<nav class="navbar navbar-expand-md navbar-light bg-light">
<a class="navbar-brand">Discuz! X3.5 升级程序</a>
<button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
<span class="navbar-toggler-icon"></span>
</button>
<div class="collapse navbar-collapse" id="navbarCollapse">
<ul class="navbar-nav mr-auto">
<li class="nav-item">
<a class="nav-link" href="https://gitee.com/ComsenzDiscuz/DiscuzX/" target="_blank">Discuz! 官方Git</a>
</li>
<li class="nav-item">
<a class="nav-link" href="https://www.discuz.net/" target="_blank">Discuz! 官方站</a>
</li>
</ul>
</div>
</nav>
</header>

END;
}

function show_footer() {
	$now = date("Y");
	print<<<END

<footer class="footer mt-auto py-3">
<div class="container">
<span class="text-muted">Powered by Discuz! Community Team. Copyright &copy; 2001-$now Tencent Cloud.</span>
</div>
</footer>
<script src="https://cdn.jsdelivr.net/npm/jquery@3.4.1/dist/jquery.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha256-/ijcOLwFf26xEYAjW75FizKVo5tnTYiQddPZoLUHHZ8=" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.4.1/dist/js/bootstrap.min.js" integrity="sha256-WqU1JavFxSAMcLP2WIOI+GB2zWmShMI82mTpLDcqFUg=" crossorigin="anonymous"></script>
</body>
</html>
END;
}

function dir_clear($dir) {
	global $lang;
	if ($directory = @dir($dir)) {
		while($entry = $directory->read()) {
			$filename = $dir.'/'.$entry;
			if (is_file($filename)) {
				@unlink($filename);
			}
		}
		$directory->close();
		@touch($dir.'/index.htm');
	}
}

function get_convert_sql($type, $table) {
	global $config;
	$table = str_replace('pre_', $config['tablepre'], $table);
	if ($type == 'innodb') {
		$query = "ALTER TABLE $table ENGINE=InnoDB;";
	} else if ($type == 'utf8mb4') {
		$query = "ALTER TABLE $table CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;";
	} else if ($type == 'check') {
		$query = "SHOW TABLE STATUS WHERE `Name` = '$table';";
	}
	return $query;
}

function get_scheme_update_sql($id, $type = "InnoDB") {
	global $config;
	global $scheme_count;
	$query = array('TRUNCATE TABLE pre_common_session;', 'TRUNCATE TABLE pre_common_member_secwhite;', 'TRUNCATE TABLE pre_common_process;', 'TRUNCATE TABLE pre_common_seccheck;', 'TRUNCATE TABLE pre_common_visit;', 'TRUNCATE TABLE pre_forum_threaddisablepos;', 'ALTER TABLE pre_common_admincp_session MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_common_credit_log MODIFY COLUMN logid INT(10) unsigned NOT NULL AUTO_INCREMENT;', 'ALTER TABLE pre_common_banned ADD COLUMN ip VARCHAR(49) NOT NULL DEFAULT \'\' AFTER id, ADD COLUMN upperip VARBINARY(16) NOT NULL DEFAULT 0x0 AFTER ip,ADD COLUMN lowerip VARBINARY(16) NOT NULL DEFAULT 0x0 AFTER ip, ADD INDEX iprange (lowerip, upperip);', 'ALTER TABLE pre_common_credit_log MODIFY COLUMN logid INT(8) unsigned NOT NULL AUTO_INCREMENT;', 'ALTER TABLE pre_common_failedip MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_common_failedlogin MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_common_invite MODIFY COLUMN inviteip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_common_member_action_log MODIFY COLUMN id INT(10) unsigned NOT NULL AUTO_INCREMENT;', 'ALTER TABLE pre_common_member_status MODIFY COLUMN regip VARCHAR(45) NOT NULL DEFAULT \'\',MODIFY COLUMN lastip VARCHAR(45) NOT NULL DEFAULT \'\',ADD COLUMN regport SMALLINT(6) unsigned NOT NULL DEFAULT \'0\' AFTER lastip;', 'ALTER TABLE pre_common_regip MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_common_remote_port MODIFY COLUMN useip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_common_searchindex MODIFY COLUMN useip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_common_session ADD COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\' AFTER sid,MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_common_task MODIFY COLUMN applicants INT(10) unsigned NOT NULL DEFAULT \'0\',MODIFY COLUMN achievers INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_common_usergroup_field ADD COLUMN allowsavenum smallint(6) unsigned NOT NULL DEFAULT \'0\' AFTER allowat, ADD COLUMN allowsavereply smallint(6) unsigned NOT NULL DEFAULT \'1\' AFTER allowat, ADD COLUMN allowsave smallint(6) unsigned NOT NULL DEFAULT \'1\' AFTER allowat, MODIFY COLUMN edittimelimit INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_common_visit MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_connect_feedlog MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_connect_tthreadlog MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_activity MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_activityapply MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_0 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_1 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_2 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_3 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_4 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_5 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_6 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_7 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_8 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_attachment_9 MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_collectioncomment MODIFY COLUMN useip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_forum_collectionteamworker MODIFY COLUMN lastvisit INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_collectionthread MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_debate MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_debatepost MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_filter_post MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_forumfield MODIFY COLUMN livetid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_forumrecommend MODIFY COLUMN tid INT(10) unsigned NOT NULL;', 'ALTER TABLE pre_forum_groupcreditslog MODIFY COLUMN logdate INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_hotreply_member MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_hotreply_number MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_memberrecommend MODIFY COLUMN tid INT(10) unsigned NOT NULL;', 'ALTER TABLE pre_forum_newthread MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_order MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\',ADD COLUMN `port` SMALLINT(6) unsigned NOT NULL DEFAULT \'0\' AFTER ip;', 'ALTER TABLE pre_forum_poll MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_polloption MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_polloption_image MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_pollvoter MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_post MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\',MODIFY COLUMN useip VARCHAR(45) NOT NULL DEFAULT \'\',MODIFY COLUMN position INT(10) unsigned NOT NULL;', 'ALTER TABLE pre_forum_post_location MODIFY COLUMN tid INT(10) unsigned DEFAULT \'0\';', 'ALTER TABLE pre_forum_postcache MODIFY COLUMN `comment` MEDIUMTEXT NOT NULL,MODIFY COLUMN rate MEDIUMTEXT NOT NULL;', 'ALTER TABLE pre_forum_postcomment MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\',MODIFY COLUMN useip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_forum_postlog MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_poststick MODIFY COLUMN tid INT(10) unsigned NOT NULL;', 'ALTER TABLE pre_forum_promotion MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\',ADD COLUMN `port` SMALLINT(6) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_relatedthread MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_replycredit MODIFY COLUMN tid INT(10) unsigned NOT NULL;', 'ALTER TABLE pre_forum_rsscache MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_sofa MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_thread MODIFY COLUMN tid INT(10) unsigned NOT NULL AUTO_INCREMENT,MODIFY COLUMN maxposition INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadaddviews MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadclosed MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threaddisablepos MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadhidelog MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadhot MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadimage MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadlog MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadmod MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadpartake MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadpreview MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_threadrush MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_forum_trade MODIFY COLUMN tid INT(10) unsigned NOT NULL;', 'ALTER TABLE pre_forum_tradelog MODIFY COLUMN tid INT(10) unsigned NOT NULL;', 'ALTER TABLE pre_forum_typeoptionvar MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_home_comment MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_home_docomment MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\',ADD COLUMN `port` SMALLINT(6) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_home_doing MODIFY COLUMN ip VARCHAR(45) NOT NULL DEFAULT \'\';', 'ALTER TABLE pre_home_follow_feed MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_home_follow_feed_archiver MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';', 'ALTER TABLE pre_home_notification MODIFY COLUMN id BIGINT(20) unsigned NOT NULL AUTO_INCREMENT;', 'ALTER TABLE pre_security_evilpost MODIFY COLUMN tid INT(10) unsigned NOT NULL DEFAULT \'0\';');
	$scheme_count = count($query);
	if ($id + 1 > $scheme_count) {
		return '';
	} else {
		return str_replace(' pre_', ' '.$config['tablepre'], $query[$id]);
	}
}

function get_innodb_scheme_update_sql($table) {
	global $config;
	$query = array('pre_common_admincp_perm' => 'ALTER TABLE pre_common_admincp_perm DROP KEY `cpgroupperm`, ADD KEY `cpgroupperm` (`cpgroupid`, `perm`(40));', 'pre_common_advertisement_custom' => 'ALTER TABLE pre_common_advertisement_custom DROP KEY `name`, ADD KEY `name` (`name`(100));', 'pre_common_banned' => 'TRUNCATE TABLE pre_common_banned;', 'pre_common_block_style' => 'ALTER TABLE pre_common_block_style DROP KEY `hash`, ADD KEY `hash` (`hash`(10)), DROP KEY `blockclass`, ADD KEY `blockclass` (`blockclass`(50));', 'pre_common_cache' => 'ALTER TABLE pre_common_cache DROP PRIMARY KEY, ADD PRIMARY KEY (`cachekey`(50));', 'pre_common_card' => 'ALTER TABLE pre_common_card DROP PRIMARY KEY, ADD PRIMARY KEY (`id`(50));', 'pre_common_member_grouppm' => 'ALTER TABLE pre_common_member_grouppm ADD INDEX gpmid(gpmid);', 'pre_common_member_profile_setting' => 'ALTER TABLE pre_common_member_profile_setting DROP PRIMARY KEY, ADD PRIMARY KEY (`fieldid`(30));', 'pre_common_member_security' => 'ALTER TABLE pre_common_member_security DROP KEY `uid`, ADD KEY `uid` (`uid`, `fieldid`(40));', 'pre_common_member_stat_field' => 'ALTER TABLE pre_common_member_stat_field DROP KEY `fieldid`, ADD KEY `fieldid` (`fieldid`(40));', 'pre_common_searchindex' => 'TRUNCATE TABLE pre_common_searchindex;', 'pre_common_setting' => 'ALTER TABLE pre_common_setting DROP PRIMARY KEY, ADD PRIMARY KEY (`skey`(40));', 'pre_common_syscache' => 'TRUNCATE TABLE pre_common_syscache;', 'pre_forum_groupfield' => 'ALTER TABLE pre_forum_groupfield DROP KEY `types`, ADD KEY `types` (`fid`, `type`(40)), DROP KEY `type`, ADD KEY `type` (`type`(40));', 'pre_forum_post' => 'ALTER TABLE pre_forum_post MODIFY COLUMN position INT unsigned NOT NULL DEFAULT \'0\'', 'pre_forum_rsscache' => 'TRUNCATE TABLE pre_forum_rsscache;', 'pre_forum_spacecache' => 'TRUNCATE TABLE pre_forum_spacecache;', 'pre_home_favorite' => 'ALTER TABLE pre_home_favorite DROP KEY `idtype`, ADD KEY `idtype` (`id`, `idtype`(40)), DROP KEY `uid`, ADD KEY `uid` (`uid`, `idtype`(40), `dateline`);', 'pre_mobile_setting' => 'ALTER TABLE pre_mobile_setting DROP PRIMARY KEY, ADD PRIMARY KEY (`skey`(40));', 'pre_portal_topic' => 'ALTER TABLE pre_portal_topic DROP KEY `name`, ADD KEY `name` (`name`(40));');
	return str_replace(' pre_', ' '.$config['tablepre'], $query[$table]);
}

function _serialize($str) {
	$l = strlen($str[2]);
	return 's:'.$l.':"'.$str[2].'";';
}

function get_serialize_list() {
	return array(
		array('pre_common_advertisement', 'parameters', 'advid', TRUE),
		array('pre_common_block', 'param', 'bid', TRUE),
		array('pre_common_block', 'blockstyle', 'bid', TRUE),
		array('pre_common_block_item', 'fields', 'itemid', TRUE),
		array('pre_common_block_item_data', 'showstyle', 'dataid', TRUE),
		array('pre_common_block_item_data', 'fields', 'dataid', TRUE),
		array('pre_common_block_style', 'template', 'styleid', TRUE),
		array('pre_common_block_style', 'fields', 'styleid', TRUE),
		array('pre_common_diy_data', 'diycontent', 'targettplname', TRUE),
		array('pre_common_magic', 'magicperm', 'magicid', TRUE),
		array('pre_common_member_field_forum', 'groups', 'uid', TRUE),
		array('pre_common_member_field_forum', 'groupterms', 'uid', TRUE),
		array('pre_common_member_field_forum_archive', 'groups', 'uid', TRUE),
		array('pre_common_member_field_forum_archive', 'groupterms', 'uid', TRUE),
		array('pre_common_member_field_home', 'blockposition', 'uid', TRUE),
		array('pre_common_member_field_home', 'privacy', 'uid', TRUE),
		array('pre_common_member_field_home', 'acceptemail', 'uid', TRUE),
		array('pre_common_member_field_home', 'magicgift', 'uid', TRUE),
		array('pre_common_member_field_home_archive', 'blockposition', 'uid', TRUE),
		array('pre_common_member_field_home_archive', 'privacy', 'uid', TRUE),
		array('pre_common_member_field_home_archive', 'acceptemail', 'uid', TRUE),
		array('pre_common_member_field_home_archive', 'magicgift', 'uid', TRUE),
		array('pre_common_member_newprompt', 'data', 'uid', TRUE),
		array('pre_common_member_stat_search', 'condition', 'optionid', TRUE),
		array('pre_common_member_verify_info', 'field', 'vid', TRUE),
		array('pre_common_patch', 'rule', 'serial', TRUE),
		array('pre_common_plugin', 'modules', 'pluginid', TRUE),
		array('pre_common_plugin', 'modules', 'pluginid', TRUE),
		array('pre_common_plugin', 'modules', 'pluginid', TRUE),
		array('pre_common_setting', 'svalue', 'skey', FALSE),
		array('pre_forum_activity', 'ufield', 'tid', TRUE),
		array('pre_forum_forumfield', 'creditspolicy', 'fid', TRUE),
		array('pre_forum_forumfield', 'formulaperm' ,'fid', TRUE),
		array('pre_forum_forumfield', 'threadtypes', 'fid', TRUE),
		array('pre_forum_forumfield', 'supe_pushsetting', 'fid', TRUE),
		array('pre_forum_forumfield', 'modrecommend', 'fid', TRUE),
		array('pre_forum_forumfield', 'extra', 'fid', TRUE),
		array('pre_forum_groupfield', 'data', 'fid', TRUE),
		array('pre_forum_grouplevel', 'creditspolicy', 'levelid', TRUE),
		array('pre_forum_grouplevel', 'postpolicy' ,'levelid', TRUE),
		array('pre_forum_grouplevel', 'specialswitch' ,'levelid', TRUE),
		array('pre_forum_medal', 'permission', 'medalid', TRUE),
		array('pre_forum_postcache', 'comment', 'pid', TRUE),
		array('pre_forum_postcache', 'rate', 'pid', TRUE),
		array('pre_forum_spacecache', 'value', 'uid', TRUE),
		array('pre_forum_threadprofile', 'template', 'id', TRUE),
		array('pre_forum_typeoption', 'rules', 'optionid', TRUE),
		array('pre_home_feed', 'title_data', 'feedid', TRUE),
		array('pre_home_feed', 'body_data', 'feedid', TRUE),
		array('pre_home_share', 'body_data', 'sid', TRUE),
		array('pre_mobile_wechat_resource', 'data', 'id', TRUE),
		array('pre_mobile_wsq_threadlist', 'svalue', 'skey', TRUE),
	);
}

function db_content_update() {
	// 开启程序所有功能
	$feats = array('portal', 'forum', 'friend', 'group', 'follow', 'collection', 'guide', 'feed', 'blog', 'doing', 'album', 'share', 'wall', 'homepage', 'ranklist', 'medal', 'task', 'magic', 'favorite');
	foreach ($feats as $type) {
		$funkey = $type.'status';
		$identifier = array('portal' => 1, 'forum' => 2, 'group' => 3, 'feed' => 4, 'ranklist' => 8, 'follow' => 9, 'guide' => 10, 'collection' => 11, 'blog' => 12, 'album' => 13, 'share' => 14, 'doing' => 15, 'friend' => 26, 'favorite' => 27, 'medal' => 29, 'task' => 30, 'magic' => 31);
		$navdata = array('available' => 1);
		$navtype = array(0, 3);
		if (in_array($type, array('blog', 'album', 'share', 'doing', 'follow', 'friend', 'favorite', 'medal', 'task', 'magic'))) {
			$navtype[] = 2;
		}
		C::t('common_nav')->update_by_navtype_type_identifier($navtype, 0, array("$type", "$identifier[$type]"), $navdata);
		C::t('common_setting')->update($funkey, 1);
	}
	// 关闭所有非系统插件
	DB::query("UPDATE ".DB::table('common_plugin')." SET available='0' WHERE modules NOT LIKE '%s:6:\"system\";i:2;%'");
	// 恢复默认风格
	define('IN_ADMINCP', true);
	require_once libfile('function/admincp');
	require_once libfile('function/importdata');
	$dir = DB::result_first("SELECT t.directory FROM ".DB::table('common_style')." s LEFT JOIN ".DB::table('common_template')." t ON t.templateid=s.templateid WHERE s.styleid='1'");
	import_styles(1, $dir, 1, 0, 0);
	C::t('common_setting')->update('styleid', 1);
}

function save_config_file($filename, $config, $default, $deletevar) {
	$config = setdefault($config, $default, $deletevar);
	$content = <<<EOT
<?php


\$_config = array();

EOT;
	$content .= getvars(array('_config' => $config));
	$content .= "\r\n// ".str_pad('  THE END  ', 50, '-', STR_PAD_BOTH)." //\r\n\r\n?>";
	if (!empty($_GET['myisam'])) {
		$content = preg_replace("/\['db'\]\['common'\]\['engine'\] = \s*'.*?'\;/i", "['db']['common']['engine'] = 'myisam';", $content);
	}
	if (!is_writable($filename) || !($len = file_put_contents($filename, $content))) {
		file_put_contents(DISCUZ_ROOT.'./data/config_global.php', $content);
		return 0;
	}
	return 1;
}

function setdefault($var, $default, $deletevar = array()) {
	foreach ($default as $k => $v) {
		if (!isset($var[$k])) {
			$var[$k] = $default[$k];
		} elseif (is_array($v)) {
			$var[$k] = setdefault($var[$k], $default[$k]);
		}
	}
	foreach ($deletevar as $k) {
		unset($var[$k]);
	}
	return $var;
}

function getvars($data, $type = 'VAR') {
	$evaluate = '';
	foreach($data as $key => $val) {
		if (!preg_match("/^[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*$/", $key)) {
			continue;
		}
		if (is_array($val)) {
			$evaluate .= buildarray($val, 0, "\${$key}")."\r\n";
		} else {
			$val = addcslashes($val, '\'\\');
			$evaluate .= $type == 'VAR' ? "\$$key = '$val';\n" : "define('".strtoupper($key)."', '$val');\n";
		}
	}
	return $evaluate;
}

function buildarray($array, $level = 0, $pre = '$_config') {
	static $ks;
	if ($level == 0) {
		$ks = array();
		$return = '';
	}

	foreach ($array as $key => $val) {
		if ($level == 0) {
			$newline = str_pad('  CONFIG '.strtoupper($key).'  ', 70, '-', STR_PAD_BOTH);
			$return .= "\r\n// $newline //\r\n";
			if ($key == 'admincp') {
				$newline = str_pad(' Founders: $_config[\'admincp\'][\'founder\'] = \'1,2,3\'; ', 70, '-', STR_PAD_BOTH);
				$return .= "// $newline //\r\n";
			}
		}

		$ks[$level] = $ks[$level - 1]."['$key']";
		if (is_array($val)) {
			$ks[$level] = $ks[$level - 1]."['$key']";
			$return .= buildarray($val, $level + 1, $pre);
		} else {
			$val =  is_string($val) || strlen($val) > 12 || !preg_match("/^\-?[1-9]\d*$/", $val) ? '\''.addcslashes($val, '\'\\').'\'' : $val;
			$return .= $pre.$ks[$level - 1]."['$key']"." = $val;\r\n";
		}
	}
	return $return;
}

function encode_file($filename) {
	if (file_exists($filename)) {
		$res = file_get_contents($filename);
		$i = pathinfo($filename);
		if (in_array($i['extension'], array('js', 'css', 'php', 'html', 'htm'))) {
			// 有的地方说 EUC-CN = GB2312，CP936 = GBK，这里都写上
			$encode = mb_detect_encoding($res, array("ASCII", "UTF-8", "GB2312", "GBK", "EUC-CN", "CP936", "GB18030", "BIG-5"));
			if (in_array($encode, array("GB2312", "GBK", "EUC-CN", "CP936", "GB18030", "BIG-5"))) {
				$res = mb_convert_encoding($res, "UTF-8", $encode);
				file_put_contents($filename, $res);
			}
		}
	}
}

function encode_tree($directory) {
	$tdir = dir($directory);
	while ($file = $tdir->read()) {
		if ((is_dir("$directory/$file")) && ($file != ".") && ($file != "..")) {
			encode_tree("$directory/$file");
		} else {
			$file ="$directory/$file";
			if (is_file($file)) {
				encode_file($file);
			}
		}
	}
}