<?php

@set_time_limit(0);
@ignore_user_abort(TRUE);
ini_set('max_execution_time', 0);
ini_set('mysql.connect_timeout', 0);

define("IN_UC", TRUE);
define('UC_ROOT', realpath('..').'/');

require UC_ROOT.'./data/config.inc.php';
require UC_ROOT.'./lib/dbi.class.php';
require UC_ROOT.'./release/release.php';

header("Content-type: text/html; charset=utf-8");

$step = !empty($_GET['step']) && in_array($_GET['step'], array('welcome', 'tips', 'license', 'envcheck', 'confirm', 'secques', 'innodb', 'utf8mb4_other', 'scheme', 'utf8mb4_user', 'serialize', 'file', 'dataupdate')) ? $_GET['step'] : 'welcome';
$theurl = htmlspecialchars($_SERVER['PHP_SELF'] ? $_SERVER['PHP_SELF'] : $_SERVER['SCRIPT_NAME']);
$lockfile = UC_ROOT.'./data/upgrade.lock';

$tables = array('uc_admins', 'uc_applications', 'uc_badwords', 'uc_domains', 'uc_failedlogins', 'uc_feeds', 'uc_friends', 'uc_mailqueue', 'uc_memberfields', 'uc_members', 'uc_mergemembers', 'uc_newpm', 'uc_notelist', 'uc_pm_indexes', 'uc_pm_lists', 'uc_pm_members', 'uc_pm_messages_0', 'uc_pm_messages_1', 'uc_pm_messages_2', 'uc_pm_messages_3', 'uc_pm_messages_4', 'uc_pm_messages_5', 'uc_pm_messages_6', 'uc_pm_messages_7', 'uc_pm_messages_8', 'uc_pm_messages_9', 'uc_protectedmembers', 'uc_settings', 'uc_sqlcache', 'uc_tags', 'uc_vars');

$table = empty($_GET['table']) ? 'uc_admins' : (in_array($_GET['table'], $tables) ? $_GET['table'] : 'uc_admins');

$scheme_count = 0;

if (!empty($_GET['lock'])) {
	@touch($lockfile);
	@unlink($theurl);
	show_msg('恭喜，您已经成功升级到 UCenter 1.7.0 版本，感谢您的使用！');
}

if (file_exists($lockfile)) {
	show_msg('请您先登录服务器，手工删除 data/upgrade.lock 文件，再次运行本文件进行升级。');
}

if ($step == 'welcome') {

	show_msg('<p class="lead">UCenter 是腾讯云旗下 Discuz! X 系列产品之间信息直接传递的一个桥梁，通过 UCenter 站长可以无缝整合腾讯云旗下 Discuz! X 系列产品，实现用户的一站式登录以及社区其他数据的交互。UCenter拥有机制完善的接口，经过简单修改便可以挂接其它任何平台的第三方的网络应用程序，随时为您的社区系统增加能量。</p><p class="lead">UCenter 1.7.0 版本在继承和完善先前产品宗旨的基础上， Discuz! 社区以“不忘初心”为主线，针对“系统安全”、“IPv6”、“用户体验”和“管理体验”几大方面，对程序进行了全面优化和打造，功能改进多达 1 余项。本程序将不定期的在官方 Git 中更新，欲追求更新版本的站长欢迎关注。</p><p class="lead">本程序将引导您从 UCenter 1.6.0 升级至 UCenter 1.7.0 ，请在升级之前做好站点全量数据（含数据库、文件）的备份操作，并小心操作。</p><p class="lead">在您准备好进行操作之后，点击“下一步”按钮继续操作。</p><p><button type="button" class="btn btn-primary" onclick="location.href=\'?step=tips\';">下一步 ></button></p>', '欢迎您执行 UCenter 1.7.0 升级程序', 1);

} else if ($step == 'tips') {

	show_msg('<p class="lead">本程序将引导您从 UCenter 1.6.0 升级至 UCenter 1.7.0 ，请在升级之前做好站点全量数据（含数据库、文件）的备份操作，并小心操作。</p><p class="lead">由于 UCenter 1.7.0 更新了数据库编码，对于您当前数据库内不支持 utf8mb4_unicode_ci 编码的用户名，本程序会将用户重命名为 15 位随机字符，请您自行在升级成功后在 UCenter 后台查询用户更名日志和通知日志，保证更名通知已经成功下发到各应用后再进行应用升级操作（对于 UCenter 对接其他非 Discuz! X 系统的站点，请确认应用正确实现了 UCenter 通知改名接口。），并在升级完成后通过站点公告、电子邮件、手机短信等多种方式手动通知此类用户通过更名卡等方式自行修改用户名。如果需要通过更名卡方式修改用户名的站点，请在转换完成后手动在后台配置道具中心的更名卡，以支持上述用户自助改名。</p><p class="lead">由于 UCenter 1.7.0 更新了数据库编码，为了防止安全提问内的中文影响用户登录，因此将为您清空安全提问，请将此情况如实告知用户，并要求用户在登录时请不要输入安全提问。如您希望自行编写兼容代码，请自行在后续流程选择不清空用户的安全提问。</p><p class="lead">由于 UCenter 1.7.0 更新了数据库编码，对于极个别采用非标准字符集用作密码的账号可能会出现密码错误的情况，遇到此情况请引导用户选择找回密码并按提示操作找回密码，重新设置密码后即可重新登录。</p><p class="lead">请不要重复执行本程序，重复执行可能导致未知的问题，如遇升级出错请不要关闭页面，尝试根据提示解决后刷新继续，如无法实现请恢复备份重新开始升级。</p><p class="lead">在您准备好进行操作之后，点击“下一步”按钮继续操作。</p><p><button type="button" class="btn btn-primary" onclick="location.href=\'?step=license\';">下一步 ></button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=welcome\';">上一步 <</button></p>', '请您阅读升级提示', 1);

} else if ($step == 'license') {

	show_msg('<p class="lead">请点击 <a href="https://gitee.com/ComsenzDiscuz/DiscuzX/raw/master/readme/license.txt" target="_blank">https://gitee.com/ComsenzDiscuz/DiscuzX/raw/master/readme/license.txt</a> 链接查看最新版最终用户授权协议。</p><p><button type="button" class="btn btn-primary" onclick="location.href=\'?step=envcheck\';">同意并下一步 ></button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=tips\';">上一步 <</button></p>', '请您阅读最终用户授权协议', 1);

} else if ($step == 'envcheck') {

	$db = new ucserver_db();
	$db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, 'utf8mb4');

	$tips = '<table class="table table-striped" style="margin: 2em 0;"><thead><tr><th scope="col">软件名称</th><th scope="col">最低要求</th><th scope="col">当前状态</th><th scope="col">是否满足</th></tr></thead><tbody>';
	$env_ok = true;
	$uc_db_ver = $db->fetch_first("SELECT * FROM ".UC_DBTABLEPRE."settings WHERE `k` = 'version'");
	$now_ver = array('Code Version' => constant('UC_SERVER_VERSION'), 'DB Version' => $uc_db_ver['v'], 'PHP' => constant('PHP_VERSION'), 'MySQL' => $db->version(), 'GD' => (function_exists('gd_info') ? preg_replace('/[^0-9.]+/', '', gd_info()['GD Version']) : false), 'XML' => function_exists('xml_parser_create'), 'mbstring' => (function_exists('mb_convert_encoding') || strtoupper(constant('UC_CHARSET')) == 'UTF-8'));// 对于UTF-8用户，不强制要求mbstring扩展
	$req_ver = array('Code Version' => '1.6.0', 'DB Version' => '1.6.0', 'PHP' => '5.6.0', 'MySQL' => '5.5.3', 'GD' => '1.0', 'XML' => true, 'mbstring' => true);// Todo: UCenter 版本1.7.0
	foreach ($now_ver as $key => $value) {
		$tips .= "<tr><th>$key</th><td>$req_ver[$key]</td><td>$value</td>";
		if ($req_ver[$key] === true) {
			if (!$value) {
				$tips .= '<td><font color="Red">❌ 不满足</font></td>';
				$env_ok = false;
			} else {
				$tips .= '<td><font color="Green">✔️ 满足</font></td>';
			}
		} else if (version_compare($value, $req_ver[$key], '<')) {
			$tips .= '<td><font color="Red">❌ 不满足</font></td>';
			$env_ok = false;
		} else {
			$tips .= '<td><font color="Green">✔️ 满足</font></td>';
		}
		$tips .= '</tr>';
	}
	$tips .= '</tbody></table><p>';
	$env_ok && $tips .= '<button type="button" class="btn btn-primary" onclick="location.href=\'?step=confirm\';">下一步 ></button> ';
	$tips .= '<button type="button" class="btn btn-secondary" onclick="location.href=\'?step=license\';">上一步 <</button></p>';
	show_msg($tips, '环境检测', 1);

} else if ($step == 'confirm') {

	show_msg('<p class="lead" style="color: red;font-weight: bold;">本程序即将开始将您的 UCenter 1.6.0 升级至 UCenter 1.7.0 ，请确认现在已经做好站点全量数据（含数据库、文件）的备份操作！当您点击“开始升级”时，升级将不可逆的开始！</p><p class="lead" style="color: red;font-weight: bold;">请务必在升级之前检查 UCenter 到各个应用的通信是否正常，并且请确认对接其他非 Discuz! X 系统的应用正确实现了 UCenter 通知改名接口，如果上述两项未实现，请自行调试通信和实现通知改名接口，否则可能导致 UCenter 升级无法正确完成。</p><p><button type="button" class="btn btn-primary" onclick="location.href=\'?step=secques\';">开始升级 ></button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=innodb\';">不清空安全提问（不推荐） > </button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=secques&myisam=1\';">不升级到InnoDB（不推荐） > </button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=scheme&myisam=1\';">不升级到InnoDB且不清空安全提问（不推荐） > </button> <button type="button" class="btn btn-secondary" onclick="location.href=\'?step=license\';">上一步 <</button></p>', '确认开始', 1);

} else if ($step == 'secques') {

	$db = new ucserver_db();
	$db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, 'utf8mb4');

	// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
	// $db->query('SET GLOBAL connect_timeout=28800');
	// $db->query('SET GLOBAL wait_timeout=28800');
	// $db->query('SET GLOBAL interactive_timeout=28800');

	$db->query(str_replace(' uc_', ' '.UC_DBTABLEPRE, 'UPDATE uc_members SET `secques`=\'\';'));

	$type = empty($_GET['myisam']) ? 'InnoDB' : 'MyISAM';
	$next = $type == 'InnoDB' ? 'innodb' : 'scheme&myisam=1';

	show_msg("安全提问清空完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$next);

} else if ($step == 'innodb') {

	@touch(UC_ROOT.'./data/install.lock');
	@unlink(UC_ROOT.'./install/index.php');

	$db = new ucserver_db();
	$db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, 'utf8mb4');

	if ($table != 'uc_vars') {
		$sql_check = get_convert_sql('check', $table);
		if (!empty($sql_check)) {
			$result = $db->fetch_first($sql_check);
			if ($result['Engine'] != 'InnoDB') {
				$sql = get_convert_sql($step, $table);
				if (!empty($sql)) {
					// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
					// $db->query('SET GLOBAL connect_timeout=28800');
					// $db->query('SET GLOBAL wait_timeout=28800');
					// $db->query('SET GLOBAL interactive_timeout=28800');
					if ($table == 'uc_badwords') {
						$db->query(str_replace(' uc_', ' '.UC_DBTABLEPRE, 'ALTER TABLE uc_badwords DROP KEY `find`, ADD KEY `find` (`find`(100));'));
					}
					$db->query($sql);
				}
			}
		}
	}

	$tmp = array_flip($tables);
	$tmpid = $tmp[$table];
	$count = count($tables);
	if ($tmpid + 1 < $count) {
		$next = $tables[++$tmpid];
		show_msg("InnoDB数据表升级进行中，$table 表升级已完成，当前进度 $tmpid / $count ，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step."&table=".$next);
	} else {
		show_msg("InnoDB数据表升级完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=scheme");
	}

} else if ($step == 'scheme') {

	@touch(UC_ROOT.'./data/install.lock');
	@unlink(UC_ROOT.'./install/index.php');

	$db = new ucserver_db();
	$db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, 'utf8mb4');

	$id = empty($_GET['id']) ? 0 : intval($_GET['id']);
	$type = empty($_GET['myisam']) ? 'InnoDB' : 'MyISAM';

	$sql = get_scheme_update_sql($id, $type);
	if (!empty($sql)) {
		// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
		// $db->query('SET GLOBAL connect_timeout=28800');
		// $db->query('SET GLOBAL wait_timeout=28800');
		// $db->query('SET GLOBAL interactive_timeout=28800');
		$db->query($sql);
		show_msg("数据库结构升级进行中，当前进度 $id / $scheme_count ，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step."&myisam=".(empty($_GET['myisam']) ? 0 : 1)."&id=".++$id);
	} else {
		show_msg("数据库结构升级完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=utf8mb4_user");
	}

} else if ($step == 'utf8mb4_user') {

	$db = new ucserver_db();
	$db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, 'utf8mb4');

	$sql_check = get_convert_sql('check', 'uc_members');
	if (!empty($sql_check)) {
		$result = $db->fetch_first($sql_check);
		if ($result['Collation'] != 'utf8mb4_unicode_ci') {
			$sql = get_convert_sql('utf8mb4', 'uc_members');
			if (!empty($sql)) {
				// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
				// $db->query('SET GLOBAL connect_timeout=28800');
				// $db->query('SET GLOBAL wait_timeout=28800');
				// $db->query('SET GLOBAL interactive_timeout=28800');
				$db->query($sql, 'SILENT');
			}
		} else {
			show_msg("utf8mb4用户表升级完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=utf8mb4_other");
		}
	}

	if ($db->errno() == 1062 && !isset($_GET['fast'])) {// 1062属于编码的问题，进行转换编码
		// 使用宅魂提供的 SQL 语句批量处理用户重名问题（不再对报错用户名进行区分，一起改掉）
		$result = $db->fetch_all("SELECT group_concat(uid) AS uids, group_concat(username), count(1) AS count FROM ".UC_DBTABLEPRE."members GROUP BY CONVERT(username USING utf8mb4) COLLATE utf8mb4_unicode_ci HAVING count > 1;");
		foreach ($result as $key => $value) {
			$arr = explode(',', $value['uids']);
			foreach ($arr as $uid) {
				if(!chgusername($uid, true)) {
					show_msg("<font color=\"red\"><b>UID ".$uid." 随机命名失败，请人工处理后再继续！</b></font>", '提示信息');
				}
			}
		}
		show_msg("部分用户名不支持utf8mb4编码，已进行随机命名，utf8mb4用户表升级进行中，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step."&fast=true");
	} elseif ($db->errno() == 1062 && isset($_GET['fast'])) {
		preg_match('/Duplicate entry \'(.*)\' for key/', $db->error(), $matches);
		$username = $matches[1];
		if (chgusername(addslashes($username))) {
			$fast = isset($_GET['fast']) ? '&fast=true' : '';
			show_msg($username." 用户名不支持utf8mb4编码，已进行随机命名，utf8mb4用户表升级进行中，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step.$fast);
		} else {
			show_msg("<font color=\"red\"><b>".$username." 用户名不支持utf8mb4编码，随机命名失败，请人工处理后再继续！</b></font>", '提示信息');
		}
	} elseif ($db->errno() != 0) {
		// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
		// $db->query('SET GLOBAL connect_timeout=28800');
		// $db->query('SET GLOBAL wait_timeout=28800');
		// $db->query('SET GLOBAL interactive_timeout=28800');
		$db->query($sql);// 如果程序接不住，那就不接了，直接报错
	} else {
		show_msg("utf8mb4用户表升级完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=utf8mb4_other");
	}

} else if ($step == 'utf8mb4_other') {

	$db = new ucserver_db();
	$db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, 'utf8mb4');

	$sql_check = get_convert_sql('check', $table);
	if (!empty($sql_check)) {
		$result = $db->fetch_first($sql_check);
		if ($result['Collation'] != 'utf8mb4_unicode_ci') {
			$sql = get_convert_sql('utf8mb4', $table);
			if (!empty($sql) && $table != 'uc_members') {
				// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
				// $db->query('SET GLOBAL connect_timeout=28800');
				// $db->query('SET GLOBAL wait_timeout=28800');
				// $db->query('SET GLOBAL interactive_timeout=28800');
				$db->query($sql);
			}
		}
	}

	$tmp = array_flip($tables);
	$tmpid = $tmp[$table];
	$count = count($tables);
	if ($tmpid + 1 < $count) {
		$next = $tables[++$tmpid];
		show_msg("utf8mb4数据表升级进行中，$table 表升级已完成，当前进度 $tmpid / $count ，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=".$step."&table=".$next);
	} else {
		show_msg("utf8mb4数据表升级完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=serialize");
	}

} else if ($step == 'serialize') {

	if (!isset($_GET['start']) && !isset($_GET['tid'])) {

		if (constant('UC_DBCHARSET') == 'utf8' || constant('UC_DBCHARSET') == 'utf8mb4') {
			show_msg("序列化数据转换无需进行，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=dataupdate");
		}
	
		$configfile = UC_ROOT.'./data/config.inc.php';
		if (is_writable($configfile)) {
			$config = file_get_contents($configfile);
			$config = preg_replace("/define\('UC_DBCHARSET',\s*'.*?'\);/i", "define('UC_DBCHARSET', 'utf8mb4');", $config);
			$config = preg_replace("/define\('UC_CHARSET',\s*'.*?'\);/i", "define('UC_CHARSET', 'utf-8');", $config);
			$fp = fopen($configfile, 'w');
			fwrite($fp, $config);
			fclose($fp);
			show_msg("序列化数据转换配置设置成功，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=serialize&start=0&tid=0");
		} else {
			show_msg('<font color="red"><b>由于配置文件不可写，程序自动修改配置文件失败。需要您手工修改 data/config.inc.php ，将 UC_DBCHARSET 常量手工改为 utf8mb4 ，将 UC_CHARSET 常量手工改为 utf8，随后 <a href="'.$theurl.'?step=seriallize&start=0&tid=0">点击此处</a> 继续操作。</b></font>', '提示信息');
		}

	}

	$db = new ucserver_db();
	$db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, 'utf8mb4');

	// 对于因数据库超时而升级失败的特大站点，请赋予升级程序所使用的 MySQL 账户 SUPER privilege 权限，并解除以下三行代码注释后再试
	// $db->query('SET GLOBAL connect_timeout=28800');
	// $db->query('SET GLOBAL wait_timeout=28800');
	// $db->query('SET GLOBAL interactive_timeout=28800');

	$limit = 100000;
	$nextid = 0;

	$start = empty($_GET['start']) ? 0 : intval($_GET['start']);
	$tid = empty($_GET['tid']) ? 0 : intval($_GET['tid']);

	$arr = get_serialize_list();

	$field = $arr[$tid];
	$stable = str_replace('uc_', constant('UC_DBTABLEPRE'), $field[0]);
	$sfield = $field[1];
	$sid = $field[2];
	$special = $field[3];

	if ($special) {
		$sql = "SELECT `$sfield`, `$sid` FROM `$stable` WHERE `$sid` > $start ORDER BY `$sid` ASC LIMIT $limit";
	} else {
		$sql = "SELECT `$sfield`, `$sid` FROM `$stable`";
	}

	$query = $db->query($sql);

	$dum = '';

	while ($values = $db->fetch_array($query)) {
		if ($special) {
			$nextid = $values[$sid];
		} else {
			$nextid = 0;
		}
		$data = $values[$sfield];
		$id = $values[$sid];
		$data = preg_replace_callback('/s:([0-9]+?):"([\s\S]*?)";/', '_serialize', $data);
		$data = addslashes($data);
		$db->query("UPDATE `$stable` SET `$sfield` = '$data' WHERE `$sid` = '$id';");
	}

	if ($nextid) {
		show_msg("序列化数据转换进行中，$stable 表升级进行中，即将进行下一步操作（第 $tid 个转换项从 $nextid 开始的数据），请稍候......", '提示信息', 0, "$theurl?step=$step&tid=$tid&start=$nextid");
	} else {
		if (++$tid < count($arr)) {
			show_msg("序列化数据转换进行中，$stable 表升级进行中，即将进行下一步操作（第 $tid 个转换项从 $nextid 开始的数据），请稍候......", '提示信息', 0, "$theurl?step=$step&tid=$tid&start=0");
		} else {
			show_msg("序列化数据转换完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=file");
		}
	}

} else if ($step == 'file') {

	encode_tree(__DIR__.'/../data/logs/');

	show_msg("文件编码转换完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?step=dataupdate");

} else if ($step == 'dataupdate') {

	$db = new ucserver_db();
	$db->connect(UC_DBHOST, UC_DBUSER, UC_DBPW, UC_DBNAME, 'utf8mb4');

	$db->query("REPLACE INTO ".constant('UC_DBTABLEPRE')."settings (k, v) VALUES('version', '1.7.0')");//note 记录数据库版本

	dir_clear(UC_ROOT.'./data/view');
	dir_clear(UC_ROOT.'./data/cache');

	if (is_dir(UC_ROOT.'./plugin/setting')) {
		dir_clear(UC_ROOT.'./plugin/setting');
		@unlink(UC_ROOT.'./plugin/setting/index.htm');
		@rmdir(UC_ROOT.'./plugin/setting');
	}

	$configfile = UC_ROOT.'./data/config.inc.php';
	if (is_writable($configfile)) {
		$config = file_get_contents($configfile);
		$config = preg_replace("/define\('UC_DBCHARSET',\s*'.*?'\);/i", "define('UC_DBCHARSET', 'utf8mb4');", $config);
		$config = preg_replace("/define\('UC_CHARSET',\s*'.*?'\);/i", "define('UC_CHARSET', 'utf-8');", $config);
		$fp = fopen($configfile, 'w');
		fwrite($fp, $config);
		fclose($fp);
	} else {
		show_msg("<font color=\"red\"><b>升级成功，但由于 UCenter 配置文件不可写，程序自动修改配置文件失败。需要您手工修改 data/config.inc.php ，将 UC_DBCHARSET 常量手工改为 utf8mb4 ，将 UC_CHARSET 常量手工改为 utf8 。并请您登录 UCenter 检查更名通知是否全部发出，如发送失败请检查站点与 UCenter 间的通信是否正常，通知全部成功发出后方可继续升级其余应用。请不要重复执行本程序，重复执行可能导致未知的问题。</b></font>", '提示信息');
	}

	chgusername_sendallnote();

	show_msg("更新缓存完成，即将进行下一步操作，请稍候......", '提示信息', 0, "$theurl?lock=1");

}

function show_msg($message, $title = '提示信息', $page = 0, $url_forward = '', $time = 1, $noexit = 0, $notice = '') {
	if ($url_forward) {
		$message = "<a href=\"$url_forward\">$message (跳转中......)</a><br />$notice<script>setTimeout(\"window.location.href ='$url_forward';\", $time);</script>";
	}

	if (!$page) {
		$message = '<p class="lead">'.$message.'</p>';
	}

	show_header();
	print<<<END
<main role="main" class="flex-shrink-0">
<div class="container">
<h1 class="mt-5">$title</h1>
$message
<p>$notice</p>
</div>
</main>
END;
	show_footer();
	!$noexit && exit();
}

function show_header() {
	print<<<END
<!DOCTYPE html>
<html lang="zh-cn" class="h-100">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<meta name="description" content="">
<meta name="author" content="Discuz! Community Team">
<meta name="generator" content="Discuz! Community Team">
<title>UCenter 1.7.0 升级程序</title>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.4.1/dist/css/bootstrap.min.css" integrity="sha256-L/W5Wfqfa0sdBNIKN9cG6QA5F2qx4qICmU2VgLruv9Y=" crossorigin="anonymous">
<style>
main > .container {padding: 15px 15px 0;}
.footer {background-color: #f5f5f5;}
.footer > .container {padding-right: 15px; padding-left: 15px;}
code {font-size: 80%;}
.lead {margin: 2em 0; line-height: 2em;}
</style>
</head>

<body class="d-flex flex-column h-100">
<header>
<nav class="navbar navbar-expand-md navbar-light bg-light">
<a class="navbar-brand">UCenter 1.7.0 升级程序</a>
<button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
<span class="navbar-toggler-icon"></span>
</button>
<div class="collapse navbar-collapse" id="navbarCollapse">
<ul class="navbar-nav mr-auto">
<li class="nav-item">
<a class="nav-link" href="https://gitee.com/ComsenzDiscuz/DiscuzX/" target="_blank">Discuz! 官方Git</a>
</li>
<li class="nav-item">
<a class="nav-link" href="https://www.discuz.net/" target="_blank">Discuz! 官方站</a>
</li>
</ul>
</div>
</nav>
</header>

END;
}

function show_footer() {
	$now = date("Y");
	print<<<END

<footer class="footer mt-auto py-3">
<div class="container">
<span class="text-muted">Powered by Discuz! Community Team. Copyright &copy; 2001-$now Tencent Cloud.</span>
</div>
</footer>
<script src="https://cdn.jsdelivr.net/npm/jquery@3.4.1/dist/jquery.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha256-/ijcOLwFf26xEYAjW75FizKVo5tnTYiQddPZoLUHHZ8=" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.4.1/dist/js/bootstrap.min.js" integrity="sha256-WqU1JavFxSAMcLP2WIOI+GB2zWmShMI82mTpLDcqFUg=" crossorigin="anonymous"></script>
</body>
</html>
END;
}

function chgusername($masterkey, $isuid = false) {
	global $db;
	if ($isuid) {
		$masterkey = intval($masterkey);
		$user = $db->fetch_first("SELECT * FROM ".UC_DBTABLEPRE."members WHERE uid='$masterkey'");
	} else {
		$user = $db->fetch_first("SELECT * FROM ".UC_DBTABLEPRE."members WHERE username='$masterkey'");
	}
	if ($user['uid']) {
		$uid = $user['uid'];
		$username = $user['username'];
		$newusername = get_random_username();
		$extinfo = 'uid='.$uid.'&oldusername='.urlencode($username).'&newusername='.urlencode($newusername);
		$db->query("UPDATE ".UC_DBTABLEPRE."members SET username='$newusername' WHERE uid='$uid'");
		$db->query("INSERT INTO ".UC_DBTABLEPRE."memberlogs SET uid='$uid', action='renameuser', extra='$extinfo'");
		return chgusername_note('renameuser', $extinfo);
	} else {
		return false;
	}
}

function chgusername_note($operation, $getdata = '') {
	global $db;
	$extra = '';
	$apps = $db->fetch_all("SELECT * FROM ".UC_DBTABLEPRE."applications");

	foreach((array)$apps as $appid => $app) {
		$appadd[] = 'app'.$app['appid']."='0'";
	}

	if ($appadd) {
		$extra = implode(',', $appadd);
		$extra = $extra ? ', '.$extra : '';
	}

	$getdata = addslashes($getdata);
	$db->query("INSERT INTO ".UC_DBTABLEPRE."notelist SET getdata='$getdata', operation='$operation', pri='0', postdata=''$extra");

	if ($db->insert_id()) {
		return $db->query("REPLACE INTO ".UC_DBTABLEPRE."vars (name, value) VALUES ('noteexists', '1');");
	} else {
		return false;
	}
}

function get_random_username() {
	return random(15);
}

function random($length, $numeric = 0) {
	if ($numeric) {
		$hash = sprintf('%0'.$length.'d', mt_rand(0, pow(10, $length) - 1));
	} else {
		$hash = '';
		$chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyz';
		$max = strlen($chars) - 1;
		for($i = 0; $i < $length; $i++) {
			$hash .= $chars[mt_rand(0, $max)];
		}
	}
	return $hash;
}

function dir_clear($dir) {
	$directory = dir($dir);
	while ($entry = $directory->read()) {
		$filename = $dir.'/'.$entry;
		if (is_file($filename)) {
			@unlink($filename);
		}
	}
	@touch($dir.'/index.htm');
	$directory->close();
}

function get_convert_sql($type, $table) {
	$table = str_replace('uc_', UC_DBTABLEPRE, $table);
	if ($type == 'innodb') {
		$query = "ALTER TABLE $table ENGINE=InnoDB;";
	} else if ($type == 'utf8mb4') {
		$query = "ALTER TABLE $table CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;";
	} else if ($type == 'check') {
		$query = "SHOW TABLE STATUS WHERE `Name` = '$table';";
	}
	return $query;
}

function get_scheme_update_sql($id, $type = "InnoDB") {
	global $scheme_count;
	$query = array('TRUNCATE TABLE uc_vars;', 'ALTER TABLE uc_members MODIFY COLUMN regip VARCHAR(45) NOT NULL DEFAULT \'\';', 'CREATE TABLE IF NOT EXISTS uc_memberlogs (lid int(10) unsigned NOT NULL AUTO_INCREMENT,uid mediumint(8) unsigned NOT NULL,action varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT \'\',extra varchar(255) NOT NULL COLLATE utf8mb4_unicode_ci DEFAULT \'\',PRIMARY KEY(lid)) ENGINE='.$type.' DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;');
	$scheme_count = count($query);
	if ($id + 1 > $scheme_count) {
		return '';
	} else {
		return str_replace(' uc_', ' '.UC_DBTABLEPRE, $query[$id]);
	}
}

function _serialize($str) {
        $l = strlen($str[2]);
        return 's:'.$l.':"'.$str[2].'";';
}

function get_serialize_list() {
	return array(
		array('uc_applications', 'extra', 'appid', TRUE),
		array('uc_pm_lists', 'lastmessage', 'plid', TRUE),
		array('uc_settings', 'v', 'k', TRUE),
	);
}

function chgusername_sendallnote() {
	global $db;
	$notes = $db->fetch_all("SELECT * FROM ".UC_DBTABLEPRE."notelist WHERE closed='0' AND operation='renameuser' ORDER BY pri DESC, noteid ASC");
	if (!empty($notes)) {
		$apps = $db->fetch_all("SELECT * FROM ".UC_DBTABLEPRE."applications");
		foreach ((array)$notes as $key => $note) {
			foreach((array)$apps as $appid => $app) {
				$appnotes = $note['app'.$app['appid']];
				if ($app['recvnote'] && $appnotes != 1 && $appnotes > -5) {
					if (chgusername_sendonenote($app['appid'], 0, $note)) {
						continue;
					} else {
						show_msg("<font color=\"red\"><b>升级成功，但部分通知发送失败，请您登录 UCenter 检查更名通知是否全部发出，如发送失败请检查站点与 UCenter 间的通信是否正常，通知全部成功发出后方可继续升级其余应用。请不要重复执行本程序，重复执行可能导致未知的问题。</b></font>", '提示信息');
					}
				}
			}
		}
	}
}

function chgusername_sendonenote($appid, $noteid = 0, $note = '') {
	global $db;
	require_once UC_ROOT.'./lib/xml.class.php';
	$return = FALSE;
	$app = $db->fetch_first("SELECT * FROM ".UC_DBTABLEPRE."applications WHERE appid='$appid'");
	if ($noteid) {
		$note = $db->fetch_first("SELECT * FROM ".UC_DBTABLEPRE."notelist WHERE noteid='$noteid'");
	}

	// 不考虑数据库方式发送，一律走实现更简单的接口方式
	$url = chgusername_get_url_code($note['operation'], $note['getdata'], $appid);
	$note['postdata'] = str_replace(array("\n", "\r"), '', $note['postdata']);
	$response = trim(dfopen2($url, 0, $note['postdata'], '', 1, $app['ip'], 60, TRUE));

	$returnsucceed = $response != '' && ($response == 1 || is_array(xml_unserialize($response)));
	$time = time();

	if ($returnsucceed) {
		$db->query("UPDATE ".UC_DBTABLEPRE."notelist SET app$appid='1', totalnum=totalnum+1, succeednum=succeednum+1, dateline='$time' WHERE noteid='$note[noteid]'", 'SILENT');
		$return = TRUE;
	} else {
		$db->query("UPDATE ".UC_DBTABLEPRE."notelist SET app$appid = app$appid-'1', totalnum=totalnum+1, dateline='$time' WHERE noteid='$note[noteid]'", 'SILENT');
		$return = FALSE;
	}
	return $return;
}

function chgusername_get_url_code($operation, $getdata, $appid) {
	global $db;
	$app = $db->fetch_first("SELECT * FROM ".UC_DBTABLEPRE."applications WHERE appid='$appid'");
	$authkey = $app['authkey'];
	$url = $app['url'];
	$apifilename = isset($app['apifilename']) && $app['apifilename'] ? $app['apifilename'] : 'uc.php';
	$action = 'action=renameuser';
	$code = urlencode(authcode("$action&".($getdata ? "$getdata&" : '')."time=".time(), 'ENCODE', $authkey));
	return $url."/api/$apifilename?code=$code";
}

function authcode($string, $operation = 'DECODE', $key = '', $expiry = 0) {

	$ckey_length = 4;

	$key = md5($key ? $key : UC_KEY);
	$keya = md5(substr($key, 0, 16));
	$keyb = md5(substr($key, 16, 16));
	$keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length): substr(md5(microtime()), -$ckey_length)) : '';

	$cryptkey = $keya.md5($keya.$keyc);
	$key_length = strlen($cryptkey);

	$string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$keyb), 0, 16).$string;
	$string_length = strlen($string);

	$result = '';
	$box = range(0, 255);

	$rndkey = array();
	for($i = 0; $i <= 255; $i++) {
		$rndkey[$i] = ord($cryptkey[$i % $key_length]);
	}

	for($j = $i = 0; $i < 256; $i++) {
		$j = ($j + $box[$i] + $rndkey[$i]) % 256;
		$tmp = $box[$i];
		$box[$i] = $box[$j];
		$box[$j] = $tmp;
	}

	for($a = $j = $i = 0; $i < $string_length; $i++) {
		$a = ($a + 1) % 256;
		$j = ($j + $box[$a]) % 256;
		$tmp = $box[$a];
		$box[$a] = $box[$j];
		$box[$j] = $tmp;
		$result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
	}

	if ($operation == 'DECODE') {
		if ((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26).$keyb), 0, 16)) {
			return substr($result, 26);
		} else {
			return '';
		}
	} else {
		return $keyc.str_replace('=', '', base64_encode($result));
	}

}

function dfopen2($url, $limit = 0, $post = '', $cookie = '', $bysocket = FALSE, $ip = '', $timeout = 15, $block = TRUE, $encodetype  = 'URLENCODE', $allowcurl = TRUE) {
	$__times__ = isset($_GET['__times__']) ? intval($_GET['__times__']) + 1 : 1;
	if ($__times__ > 2) {
		return '';
	}
	$url .= (strpos($url, '?') === FALSE ? '?' : '&')."__times__=$__times__";
	return dfopen($url, $limit, $post, $cookie, $bysocket, $ip, $timeout, $block, $encodetype, $allowcurl);
}

function dfopen($url, $limit = 0, $post = '', $cookie = '', $bysocket = FALSE	, $ip = '', $timeout = 15, $block = TRUE, $encodetype  = 'URLENCODE', $allowcurl = TRUE) {
	$return = '';
	$matches = parse_url($url);
	$scheme = $matches['scheme'];
	$host = $matches['host'];
	$path = $matches['path'] ? $matches['path'].($matches['query'] ? '?'.$matches['query'] : '') : '/';
	$port = !empty($matches['port']) ? $matches['port'] : ($matches['scheme'] == 'https' ? 443 : 80);

	if (function_exists('curl_init') && function_exists('curl_exec') && $allowcurl) {
		$ch = curl_init();
		$ip && curl_setopt($ch, CURLOPT_HTTPHEADER, array("Host: ".$host));
		curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
		curl_setopt($ch, CURLOPT_URL, $scheme.'://'.($ip ? $ip : $host).':'.$port.$path);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		if ($post) {
			curl_setopt($ch, CURLOPT_POST, 1);
			if ($encodetype == 'URLENCODE') {
				curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
			} else {
				parse_str($post, $postarray);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $postarray);
			}
		}
		if ($cookie) {
			curl_setopt($ch, CURLOPT_COOKIE, $cookie);
		}
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		$data = curl_exec($ch);
		$status = curl_getinfo($ch);
		$errno = curl_errno($ch);
		curl_close($ch);
		if ($errno || $status['http_code'] != 200) {
			return;
		} else {
			return !$limit ? $data : substr($data, 0, $limit);
		}
	}

	if ($post) {
		$out = "POST $path HTTP/1.0\r\n";
		$header = "Accept: */*\r\n";
		$header .= "Accept-Language: zh-cn\r\n";
		$boundary = $encodetype == 'URLENCODE' ? '' : ';'.substr($post, 0, trim(strpos($post, "\n")));
		$header .= $encodetype == 'URLENCODE' ? "Content-Type: application/x-www-form-urlencoded\r\n" : "Content-Type: multipart/form-data$boundary\r\n";
		$header .= "User-Agent: $_SERVER[HTTP_USER_AGENT]\r\n";
		$header .= "Host: $host:$port\r\n";
		$header .= 'Content-Length: '.strlen($post)."\r\n";
		$header .= "Connection: Close\r\n";
		$header .= "Cache-Control: no-cache\r\n";
		$header .= "Cookie: $cookie\r\n\r\n";
		$out .= $header.$post;
	} else {
		$out = "GET $path HTTP/1.0\r\n";
		$header = "Accept: */*\r\n";
		$header .= "Accept-Language: zh-cn\r\n";
		$header .= "User-Agent: $_SERVER[HTTP_USER_AGENT]\r\n";
		$header .= "Host: $host:$port\r\n";
		$header .= "Connection: Close\r\n";
		$header .= "Cookie: $cookie\r\n\r\n";
		$out .= $header;
	}

	$fpflag = 0;
	if (!$fp = @fsocketopen(($scheme == 'https' ? 'ssl://' : '').($scheme == 'https' ? $host : ($ip ? $ip : $host)), $port, $errno, $errstr, $timeout)) {
		$context = array(
			'http' => array(
				'method' => $post ? 'POST' : 'GET',
				'header' => $header,
				'content' => $post,
				'timeout' => $timeout,
			),
		);
		$context = stream_context_create($context);
		$fp = @fopen($scheme.'://'.($scheme == 'https' ? $host : ($ip ? $ip : $host)).':'.$port.$path, 'b', false, $context);
		$fpflag = 1;
	}

	if (!$fp) {
		return '';
	} else {
		stream_set_blocking($fp, $block);
		stream_set_timeout($fp, $timeout);
		@fwrite($fp, $out);
		$status = stream_get_meta_data($fp);
		if (!$status['timed_out']) {
			while (!feof($fp) && !$fpflag) {
				if (($header = @fgets($fp)) && ($header == "\r\n" ||  $header == "\n")) {
					break;
				}
			}

			$stop = false;
			while (!feof($fp) && !$stop) {
				$data = fread($fp, ($limit == 0 || $limit > 8192 ? 8192 : $limit));
				$return .= $data;
				if ($limit) {
					$limit -= strlen($data);
					$stop = $limit <= 0;
				}
			}
		}
		@fclose($fp);
		return $return;
	}
}

function encode_file($filename) {
	if (file_exists($filename)) {
		$res = file_get_contents($filename);
		$i = pathinfo($filename);
		if (in_array($i['extension'], array('js', 'css', 'php', 'html', 'htm'))) {
			// 有的地方说 EUC-CN = GB2312，CP936 = GBK，这里都写上
			$encode = mb_detect_encoding($res, array("ASCII", "UTF-8", "GB2312", "GBK", "EUC-CN", "CP936", "GB18030", "BIG-5"));
			if (in_array($encode, array("GB2312", "GBK", "EUC-CN", "CP936", "GB18030", "BIG-5"))) {
				$res = mb_convert_encoding($res, "UTF-8", $encode);
				file_put_contents($filename, $res);
			}
		}
	}
}

function encode_tree($directory) {
	$tdir = dir($directory);
	while ($file = $tdir->read()) {
		if ((is_dir("$directory/$file")) && ($file != ".") && ($file != "..")) {
			encode_tree("$directory/$file");
		} else {
			$file ="$directory/$file";
			if (is_file($file)) {
				encode_file($file);
			}
		}
	}
}